/* rexx, purpose: invokes unarchiver routines according to file-extension */
/* does not extract, but shows the archivfile contents using editor       */
/* V0.1, ilja kaufmann, TeamOS/2 Franken, kiwi@perelin.de, 14.07.2001     */

editor='e'  /* you may change this to 'vi' or 'epm' or whatever you prefer */

'@echo off'
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs


parse arg parameter       /* bergebene Parameter aufnehmen */
say parameter
parameter=translate(parameter,'\','/')
say parameter

/* get additional parameters from environment */
temp_dir=strip(value("TEMP", ,"OS2ENVIRONMENT"),Trailing,'\')
say temp_dir
temp_dir=translate(temp_dir,'\','/')
say temp_dir

/* Dateiname extrahieren - ist jeweils das letzte wort in 'parameter' */

parameter=Reverse(Parameter)           /* zeichenkette rckwrts */

if pos('"', parameter)=0 then do                /* falls dateiname nicht in anfhrungszeichen ...*/
    parse var parameter datei parameter    /* ...erstes wort rausholen */
end /* do */
else do                                                 /* wenn dateiname in anfhrungszeichen... */
  p=lastpos('"', parameter)                      /* ...die ersten " suchen */
  p=pos(" ", parameter, p)                       /* ...nchstes leerzeichen unterhalb der " */
  if p=0 then p=length(parameter)+1         /* ...gab es keines -> ganzen parameterstring als dateinamen */
  datei=substr(parameter, 1, p-1)              /* ...dateiname aus parameter extrahieren */
  do while pos('"', datei)>0                        /* ... alle " aus dateinamen lschen */
     datei=delstr(datei, pos('"', datei),1 )
  end /* do */
  parameter=delstr(parameter, 1, p)     /* dateiname aus parameter lschen */
end /* do */

parameter=reverse(parameter)                    /* wieder zurckdrehen */
datei=reverse(datei)

/* Testweise ausgabe des erkannten dateinamen und der restparameter */

say
say "Datei: " datei
say "Parameter: " parameter

/* say chars(datei) */
if chars(datei)<1 then do     /* wenn leere datei... */
  say
  say 'File 'datei' is empty or nonexistent'
  say 'correct filename or use drag-n-drop'
  say
  say 'press enter to exit'
  pull ok
  exit
end /* do */

/* neuen Ausgabedateinamen kreieren mit ...?.* drin */

p=lastpos('\', datei)                      /* ...den letzten '\' suchen */
if p>0 then do
  pf=substr(datei,1,p-1)                        /* pfad der datei erkennen */
end /*if */
else do
  pf=directory()
end /* else */
datname=substr(datei,p+1)                   /* dateiname ohne pfad */
neudir=directory(pf)                      /* nach "pfad" wechseln */

say '-'datname'-'

select           /* welches archivformat haben wir hier denn... */
   when right(translate(datname),4)='.ZIP' then do
     tempfile=temp_dir||'\'||substr(datname,1,length(datname)-4)||'_zip_dir.t'
     'unzip -l "'||datname||'" > "'||tempfile'"'                      /* unzip aufrufen */
   end  /* Do */
   when right(translate(datname),7)='.TAR.GZ' then do
     tempfile=temp_dir||'\'||substr(datname,1,length(datname)-7)||'_targz_dir.t'
     'tar --list --zip -f "'datname'" > "'||tempfile'"'
   end  /* Do */
   when right(translate(datname),4)='.TGZ' then do
     tempfile=temp_dir||'\'||substr(datname,1,length(datname)-4)||'_tgz_dir.t'
     'tar --list --zip -f "'datname'" > "'||tempfile'"'
   end  /* Do */
   when right(translate(datname),4)='.TAR' then do
     tempfile=temp_dir||'\'||substr(datname,1,length(datname)-4)||'_tar_dir.t'
     'tar --list -f "'datname'" > "'||tempfile'"'
   end  /* Do */
   when right(translate(datname),4)='.LZH' then do
     tempfile=temp_dir||'\'||substr(datname,1,length(datname)-4)||'_lzh_dir.t'
     'lh32 L "'datname'" > "'||tempfile'"'
   end  /* Do */
   when right(translate(datname),4)='.RAR' then do
     tempfile=temp_dir||'\'||substr(datname,1,length(datname)-4)||'_rar_dir.t'
     'cp "'datname'" "'temp_dir'\temp_'datname'"'
     'rar l "'temp_dir'\temp_'datname'" > "'||tempfile'"'
     'rm "'temp_dir'\temp_'datname'"'
   end  /* Do */
   when right(translate(datname),4)='.ZOO' then do
     tempfile=temp_dir||'\'||substr(datname,1,length(datname)-4)||'_zoo_dir.t'
     'zoo l "'datname'" > "'||tempfile'"'
   end  /* Do */
   otherwise do
     say 'could not determine archiv format'
     call stop
   end /* otherwise */
end  /* select */
Call SysSleep(1)
'start /F 'editor' "'tempfile'"'
Call SysSleep(3)
'del 'tempfile

exit


stop:
say
say 'press return to exit'
pull ok
exit
return



/* routine um alle 'such' in der variable 'in' durch den ausdruck 'durch' zu ersetzen */

replaceall:
  parse arg such,in,durch,ab
  if ab="" then ab=1
  such_l=length(such)
  durch_l=length(durch)
  ipos=pos(such,in,ab)
  do while ipos>0
    in=substr(in,1,ipos-1)''durch''substr(in,ipos+such_l)
    ipos=pos(such,in,ipos+durch_l)
  end  /* while */
return in;

