/* rexx, purpose: invokes unarchiver routines according to file-extension */
/* let archives be unpacked in new created dir, opens that dir on wps     */
/* V0.1, ilja kaufmann, TeamOS/2 Franken, kiwi@perelin.de, 28.08.2001     */
/* needs: rm, cp, open, zip, tar, gz, lh32, rar, zoo                      */

parse arg parameter       /* bergebene Parameter aufnehmen */
parameter=translate(parameter,'/','\')

/* Dateiname extrahieren - ist jeweils das letzte wort in 'parameter' */

parameter=Reverse(Parameter)           /* zeichenkette rckwrts */

if pos('"', parameter)=0 then do                /* falls dateiname nicht in anfhrungszeichen ...*/
    parse var parameter datei parameter    /* ...erstes wort rausholen */
end /* do */
else do                                                 /* wenn dateiname in anfhrungszeichen... */
  p=lastpos('"', parameter)                      /* ...die ersten " suchen */
  p=pos(" ", parameter, p)                       /* ...nchstes leerzeichen unterhalb der " */
  if p=0 then p=length(parameter)+1         /* ...gab es keines -> ganzen parameterstring als dateinamen */
  datei=substr(parameter, 1, p-1)              /* ...dateiname aus parameter extrahieren */
  do while pos('"', datei)>0                        /* ... alle " aus dateinamen lschen */
     datei=delstr(datei, pos('"', datei),1 )
  end /* do */
  parameter=delstr(parameter, 1, p)     /* dateiname aus parameter lschen */
end /* do */

parameter=reverse(parameter)                    /* wieder zurckdrehen */
datei=reverse(datei)

/* Testweise ausgabe des erkannten dateinamen und der restparameter */

say
say "Datei: " datei
say "Parameter: " parameter

/* say chars(datei) */
if chars(datei)<1 then do     /* wenn leere datei... */
  say
  say 'File 'datei' is empty or nonexistent'
  say 'correct filename or use drag-n-drop'
  say
  say 'press enter to exit'
  pull ok
  exit
end /* do */

/* neuen Ausgabedateinamen kreieren mit ...?.* drin */

p=lastpos('/', datei)                      /* ...den letzten '\' suchen */
if p>0 then do
  pf=substr(datei,1,p-1)                        /* pfad der datei erkennen */
end /*if */
else do
  pf=directory()
end /* else */
datname=substr(datei,p+1)                   /* dateiname ohne pfad */
l=pos('.', datei,p+1)-p-1                  /* laenge des dateinamen ohne endungen */
if l<1 then l=length(datei)-p              /* falls zu kurz mit endung */
or=substr(datei,p+1,l)                       /* dateinamen ohne pfad */
neudir=directory(pf)                      /* nach "pfad" wechseln */
'mkdir 'or                                 /* dort ordner mit dateinamen anlegen */

/* bei gelegenheit kopieren fr unzip durch parameter -d or ersetzen */



select           /* welches archivformat haben wir hier denn... */
   when right(translate(datname),4)='.ZIP' then do
     'unzip "'datname'" -d 'or                         /* unzip aufrufen */
     neudir=directory(pf'/'or)                  /* ins neue dir wechseln */
   end  /* Do */
   when right(translate(datname),7)='.TAR.GZ' | right(translate(datname),4)='.TGZ' then do
     'cp "'datname'" "'or'/'datname'"'              /* datei in ordner kopieren */
     neudir=directory(pf'/'or)                  /* ins neue dir wechseln */
     'tar --zip -xf "'datname'"'
     'rm "'datname'"'              /* archivdatei-kopie lschen */
   end  /* Do */
   when right(translate(datname),4)='.TAR' then do
     'cp "'datname'" "'or'/'datname'"'              /* datei in ordner kopieren */
     neudir=directory(pf'/'or)                  /* ins neue dir wechseln */
     'tar -xf "'datname'"'
     'rm "'datname'"'              /* archivdatei-kopie lschen */
   end  /* Do */
   when right(translate(datname),4)='.LZH' then do
     'cp "'datname'" "'or'/'datname'"'              /* datei in ordner kopieren */
     neudir=directory(pf'/'or)                  /* ins neue dir wechseln */
     'lh32 X /s /o "'datname'"'
     'rm "'datname'"'              /* archivdatei-kopie lschen */
   end  /* Do */
   when right(translate(datname),4)='.RAR' then do
     'cp "'datname'" "'or'/'datname'"'              /* datei in ordner kopieren */
     neudir=directory(pf'/'or)                  /* ins neue dir wechseln */
     'rar x "'datname'"'
     'rm "'datname'"'              /* archivdatei-kopie lschen */
   end  /* Do */
   when right(translate(datname),4)='.ZOO' then do
     'cp "'datname'" "'or'/'datname'"'              /* datei in ordner kopieren */
     neudir=directory(pf'/'or)                  /* ins neue dir wechseln */
     'zoo x/ "'datname'"'
     'rm "'datname'"'              /* archivdatei-kopie lschen */
   end  /* Do */
   when right(translate(datname),4)='.ARJ' then do
     'cp "'datname'" "'or'/'datname'"'              /* datei in ordner kopieren */
     neudir=directory(pf'/'or)                  /* ins neue dir wechseln */
     'unarj e "'datname'"'
     'rm "'datname'"'              /* archivdatei-kopie lschen */
   end  /* Do */
   otherwise do
     say 'could not determine archiv format'
     call stop
   end /* otherwise */
end  /* select */


'open .'                    /* programm 'open' aufrufen um aktuelles dir auf desktop zu ffnen */
neudir=directory(pf)                      /* ins vorige dir zurck */

exit


stop:
say
say 'press return to exit'
pull ok
exit
return


