/* rexx, purpose: invokes unarchiver routines according to file-extension */
/* V0.1, ilja kaufmann, TeamOS/2 Franken, kiwi@perelin.de, 14.07.2001     */

parse arg parameter       /* bergebene Parameter aufnehmen */
parameter=translate(parameter,'/','\')

/* Dateiname extrahieren - ist jeweils das letzte wort in 'parameter' */

parameter=Reverse(Parameter)           /* zeichenkette rckwrts */

if pos('"', parameter)=0 then do                /* falls dateiname nicht in anfhrungszeichen ...*/
    parse var parameter datei parameter    /* ...erstes wort rausholen */
end /* do */
else do                                                 /* wenn dateiname in anfhrungszeichen... */
  p=lastpos('"', parameter)                      /* ...die ersten " suchen */
  p=pos(" ", parameter, p)                       /* ...nchstes leerzeichen unterhalb der " */
  if p=0 then p=length(parameter)+1         /* ...gab es keines -> ganzen parameterstring als dateinamen */
  datei=substr(parameter, 1, p-1)              /* ...dateiname aus parameter extrahieren */
  do while pos('"', datei)>0                        /* ... alle " aus dateinamen lschen */
     datei=delstr(datei, pos('"', datei),1 )
  end /* do */
  parameter=delstr(parameter, 1, p)     /* dateiname aus parameter lschen */
end /* do */

parameter=reverse(parameter)                    /* wieder zurckdrehen */
datei=reverse(datei)

/* Testweise ausgabe des erkannten dateinamen und der restparameter */

say
say "Datei: " datei
say "Parameter: " parameter

/* say chars(datei) */
if chars(datei)<1 then do     /* wenn leere datei... */
  say
  say 'File 'datei' is empty or nonexistent'
  say 'correct filename or use drag-n-drop'
  say
  say 'press enter to exit'
  pull ok
  exit
end /* do */

/* neuen Ausgabedateinamen kreieren mit ...?.* drin */

p=lastpos('/', datei)                      /* ...den letzten '\' suchen */
if p>0 then do
  pf=substr(datei,1,p-1)                        /* pfad der datei erkennen */
end /*if */
else do
  pf=directory()
end /* else */
datname=substr(datei,p+1)                   /* dateiname ohne pfad */
neudir=directory(pf)                      /* nach "pfad" wechseln */

select           /* welches archivformat haben wir hier denn... */
   when right(translate(datname),4)='.ZIP' then do
     'unzip "'datname'"'                         /* unzip aufrufen */
   end  /* Do */
   when right(translate(datname),7)='.TAR.GZ' | right(translate(datname),4)='.TGZ' then do
     'tar --zip -xf "'datname'"'
   end  /* Do */
   when right(translate(datname),4)='.TAR' then do
     'tar -xf "'datname'"'
   end  /* Do */
   when right(translate(datname),3)='.GZ' then do
     'gzip -d "'datname'"'
   end  /* Do */
   when right(translate(datname),4)='.LZH' then do
     'lh32 X /s /o "'datname'"'
   end  /* Do */
   when right(translate(datname),3)='.BZ' then do
     'bzip2 -d "'datname'"'
   end  /* Do */
   when right(translate(datname),4)='.BZ2' then do
     'bzip2 -d "'datname'"'
   end  /* Do */
   when right(translate(datname),4)='.ARJ' then do
     'unarj e "'datname'"'
   end  /* Do */
   when right(translate(datname),4)='.RAR' then do
     'cp "'datname'" "temp_'datname'"'
     'rar2 x "temp_'datname'"'
     'rm "temp_'datname'"'
   end  /* Do */
   when right(translate(datname),4)='.ZOO' then do
     'zoo x/ "'datname'"'
   end  /* Do */
   otherwise do
     say 'could not determine archiv format'
     call stop
   end /* otherwise */
end  /* select */

exit


stop:
say
say 'press return to exit'
pull ok
exit
return


